/* Quicksort for Benchmark   Aus der Zeitschrift Byte Juli 1987
   Vol.12, No.8 S.105/106                                         */

#include <stdio.h>
#include <osbind.h>
#include "zeit.h"

#define MAXNUM 1000
#define COUNT  100
#define MODULUS ((long) 0x20000)
#define C 13849L
#define A 25173L

long seed = 7L;
long random();
long buffer[MAXNUM] = {0};

main()
{
   int i,j;
   long temp;
  
	 printf("\nQuicksort Test, aus Byte July '87 \n");

	 schreibzeit();


   printf("Filling array and sorting %d times\n",COUNT);
   for(i=0;i<COUNT;++i) {
      for(j=0;j<MAXNUM;++j) {
         temp = random(MODULUS);
         if(temp<0L)
            temp = (-temp);
         buffer[j] = temp;
      }
/*      printf("Buffer full, iteration %d\n",i); */
      quick(0,MAXNUM-1,buffer);
   }

schreibzeit();
getchar();
}

quick(lo,hi,base)
   int lo,hi;
   long base[];
   {
      int i,j;
      long pivot,temp;

      if(lo<hi)
      {
         for(i=lo,j=hi-1,pivot=base[hi];i<j;)
         {
            while(i<hi&&base[i]<=pivot)
               ++i;
            while(j>lo&&base[j]>=pivot)
               --j;
            if(i<j)
            {
               temp = base[i];
               base[i] = base[j];
               base[j] = temp;
            }
         }
         temp = base[i];
         base[i] = base[hi];
         base[hi] = temp;
         quick(lo,i-1,base);
         quick(i+1,hi,base);
      }
   }

 long random(size)
 long size;
 {
    seed = seed * A + C;
    return(seed % size);
 }




 
