#include <stdio.h>

typedef struct syszeit
{
	unsigned sec : 5;
  unsigned min : 6;
  unsigned std : 5;
}	SYSZEIT;

typedef union toszeit
{
	SYSZEIT time;
	int zeitwert;
} TOSZEIT;

TOSZEIT anfang,ende;

void schreibzeit()
{
	TOSZEIT mytime;
  
	mytime.zeitwert = gemdos(0x2c);
  printf("\n------> %2d:%2d:%2d \n",
         mytime.time.std,mytime.time.min,mytime.time.sec * 2);
}
		
void erstezeit()
{
  anfang.zeitwert = gemdos(0x2c);
}

void letztezeit()
{
  ende.zeitwert = gemdos(0x2c);
}

void schreibdiff()
{
  TOSZEIT mytime;

  if (anfang.time.std > ende.time.std)
  { 
    printf("\n Krutzikreuzgrumpfkrotzeldamibh\n");
    mytime.time.std = 0; /* wird hoffentlich nie passieren */
  }
  else mytime.time.std = ende.time.std - anfang.time.std;

  if (anfang.time.min > ende.time.min)
  {
    mytime.time.min = (60 - anfang.time.min) + ende.time.min;
    mytime.time.std--;
  }
  else mytime.time.min = ende.time.min - anfang.time.min;

  if (anfang.time.sec > ende.time.sec) 
  {
    mytime.time.sec = (60 - anfang.time.sec) + ende.time.sec;
    mytime.time.min--;
  } 
  else mytime.time.sec = ende.time.sec - anfang.time.sec;

  printf("\n------> %2d:%2d:%2d \n",
         mytime.time.std,mytime.time.min,mytime.time.sec * 2);
  getchar();
}