/* savage.c   floating-point performance test   (Benchmark)
   Entnommen aus der Zeitschrift Byte  Juli 1987 Vol.12, No.8 S.106  */

#include <stdio.h>
#include <osbind.h>
#include "zeit.h"
#include <math.h>

#define ILOOP    25000
extern double    tan(),atan(),exp(),log(),sqrt();

main()
{
   int i;
   double a;

	 printf("\nSavage Benchmark, aus Byte July '87\n");
   
   schreibzeit();

	 printf("%4d loops\n",ILOOP);
   a = 1.0;
   for(i=1;i<=(ILOOP-1);i++)
      a = tan(atan(exp(log(sqrt(a*a))))) + 1.0;
   printf("a = %20.14e\n",a);
   schreibzeit();
   getchar();
}

 
